| OpenCV 3.4.1 Open Source Computer Vision

Public Types | Public Member Functions | Static Public Member Functions | List of all members
cv::StereoBM Class Referenceabstract
Camera Calibration and 3D Reconstruction

Class for computing stereo correspondence using the block matching algorithm, introduced and contributed to OpenCV by K. Konolige. More...

`#include "calib3d.hpp"`

Inheritance diagram for cv::StereoBM:

## Public Types
enum | { PREFILTER_NORMALIZED_RESPONSE = 0, PREFILTER_XSOBEL = 1 }
Public Types inherited from cv::StereoMatcher
enum | { DISP_SHIFT = 4, DISP_SCALE = (1 << DISP_SHIFT) }

## Public Member Functions
virtual int | getPreFilterCap () const =0
virtual int | getPreFilterSize () const =0
virtual int | getPreFilterType () const =0
virtual Rect | getROI1 () const =0
virtual Rect | getROI2 () const =0
virtual int | getSmallerBlockSize () const =0
virtual int | getTextureThreshold () const =0
virtual int | getUniquenessRatio () const =0
virtual void | setPreFilterCap (int preFilterCap)=0
virtual void | setPreFilterSize (int preFilterSize)=0
virtual void | setPreFilterType (int preFilterType)=0
virtual void | setROI1 (Rect roi1)=0
virtual void | setROI2 (Rect roi2)=0
virtual void | setSmallerBlockSize (int blockSize)=0
virtual void | setTextureThreshold (int textureThreshold)=0
virtual void | setUniquenessRatio (int uniquenessRatio)=0
Public Member Functions inherited from cv::StereoMatcher
virtual void | compute (InputArray left, InputArray right, OutputArray disparity)=0
| Computes disparity map for the specified stereo pair. More...
virtual int | getBlockSize () const =0
virtual int | getDisp12MaxDiff () const =0
virtual int | getMinDisparity () const =0
virtual int | getNumDisparities () const =0
virtual int | getSpeckleRange () const =0
virtual int | getSpeckleWindowSize () const =0
virtual void | setBlockSize (int blockSize)=0
virtual void | setDisp12MaxDiff (int disp12MaxDiff)=0
virtual void | setMinDisparity (int minDisparity)=0
virtual void | setNumDisparities (int numDisparities)=0
virtual void | setSpeckleRange (int speckleRange)=0
virtual void | setSpeckleWindowSize (int speckleWindowSize)=0
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state. More...
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read. More...
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage. More...
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage. More...
void | write (const Ptr< FileStorage > &fs, const String &name=String()) const
| simplified API for language bindings This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...

## Static Public Member Functions
static Ptr< StereoBM > | create (int numDisparities=0, int blockSize=21)
| Creates StereoBM object. More...
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file. More...
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String. More...
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node. More...

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class for computing stereo correspondence using the block matching algorithm, introduced and contributed to OpenCV by K. Konolige.

## Member Enumeration Documentation

## § anonymous enum

anonymous enum

Enumerator
PREFILTER_NORMALIZED_RESPONSE |
PREFILTER_XSOBEL |

## Member Function Documentation

## § create()

static Ptr<StereoBM> cv::StereoBM::create | ( | int | numDisparities = `0`,
|  | int | blockSize = `21`
| ) |  |
| static

Python:
| retval | = | cv.StereoBM_create( | [, numDisparities[, blockSize]] | )

Creates StereoBM object.

Parameters

  numDisparities | the disparity search range. For each pixel algorithm will find the best disparity from 0 (default minimum disparity) to numDisparities. The search range can then be shifted by changing the minimum disparity.
  blockSize | the linear size of the blocks compared by the algorithm. The size should be odd (as the block is centered at the current pixel). Larger block size implies smoother, though less accurate disparity map. Smaller block size gives more detailed disparity map, but there is higher chance for algorithm to find a wrong correspondence.

The function create StereoBM object. You can then call StereoBM::compute() to compute disparity for a specific stereo pair.

## § getPreFilterCap()

virtual int cv::StereoBM::getPreFilterCap | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.StereoBM.getPreFilterCap( |  | )

## § getPreFilterSize()

virtual int cv::StereoBM::getPreFilterSize | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.StereoBM.getPreFilterSize( |  | )

## § getPreFilterType()

virtual int cv::StereoBM::getPreFilterType | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.StereoBM.getPreFilterType( |  | )

## § getROI1()

virtual Rect cv::StereoBM::getROI1 | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.StereoBM.getROI1( |  | )

## § getROI2()

virtual Rect cv::StereoBM::getROI2 | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.StereoBM.getROI2( |  | )

## § getSmallerBlockSize()

virtual int cv::StereoBM::getSmallerBlockSize | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.StereoBM.getSmallerBlockSize( |  | )

## § getTextureThreshold()

virtual int cv::StereoBM::getTextureThreshold | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.StereoBM.getTextureThreshold( |  | )

## § getUniquenessRatio()

virtual int cv::StereoBM::getUniquenessRatio | ( |  | ) | const
| pure virtual

Python:
| retval | = | cv.StereoBM.getUniquenessRatio( |  | )

## § setPreFilterCap()

virtual void cv::StereoBM::setPreFilterCap | ( | int | preFilterCap | ) |
| pure virtual

Python:
| None | = | cv.StereoBM.setPreFilterCap( | preFilterCap | )

## § setPreFilterSize()

virtual void cv::StereoBM::setPreFilterSize | ( | int | preFilterSize | ) |
| pure virtual

Python:
| None | = | cv.StereoBM.setPreFilterSize( | preFilterSize | )

## § setPreFilterType()

virtual void cv::StereoBM::setPreFilterType | ( | int | preFilterType | ) |
| pure virtual

Python:
| None | = | cv.StereoBM.setPreFilterType( | preFilterType | )

## § setROI1()

virtual void cv::StereoBM::setROI1 | ( | Rect | roi1 | ) |
| pure virtual

Python:
| None | = | cv.StereoBM.setROI1( | roi1 | )

## § setROI2()

virtual void cv::StereoBM::setROI2 | ( | Rect | roi2 | ) |
| pure virtual

Python:
| None | = | cv.StereoBM.setROI2( | roi2 | )

## § setSmallerBlockSize()

virtual void cv::StereoBM::setSmallerBlockSize | ( | int | blockSize | ) |
| pure virtual

Python:
| None | = | cv.StereoBM.setSmallerBlockSize( | blockSize | )

## § setTextureThreshold()

virtual void cv::StereoBM::setTextureThreshold | ( | int | textureThreshold | ) |
| pure virtual

Python:
| None | = | cv.StereoBM.setTextureThreshold( | textureThreshold | )

## § setUniquenessRatio()

virtual void cv::StereoBM::setUniquenessRatio | ( | int | uniquenessRatio | ) |
| pure virtual

Python:
| None | = | cv.StereoBM.setUniquenessRatio( | uniquenessRatio | )

The documentation for this class was generated from the following file:

- calib3d/include/opencv2/calib3d.hpp